2007-01-20  KUBO Takehiro  <kubo@jiubao.org>
	* lib/oci8.rb.in: don't call OCIEnv.create when initializing.
	* release as 0.1-rc1.

2007-01-19  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/oraconf.rb: fix bugs on windows created by the previous commit.

2007-01-08  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/oraconf.rb: check whether Full Client or Instant Client by checking
	  load library path.

2007-01-03  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/env.c: raise "OCI Library Initialization Error" message
	    if no message can not be retrieved while OCIEnv.create.
	* ext/oci8/oraconf.rb, ext/oci8/extconf.rb: refactor oraconf.rb.
	* lib/oci8.rb.in: don't raise OCIError on requireing oci8. raise
	    the error when connecting to the Oracle. (for active record)

2006-12-09  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/env.c, ext/oci8/handle.c, ext/oci8/oci8.c, ext/oci8/oci8.h,
	  ext/oci8/stmt.c: add OCIFileLocator.
	* ext/oci8/lob.c: fix OCILobLocator#open to accept a second argument.
	    add OCIFileLocator#name, OCIFileLocator#set_name and
	    OCIFileLocator#exists?
	* ext/oci8/svcctx.c: add OCISvcCtx#close_all_files.
	* lib/oci8.rb.in: add OCI8::BFILE and OCI8::BindType::BFILE.

2006-12-05  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/attr.c, ext/oci8/bind.c, ext/oci8/error.c, ext/oci8/oci8.h,
	  ext/oci8/ocinumber.c, ext/oci8/oradate.c, ext/oci8/oranumber.c, 
	  ext/oci8/stmt.c: use RSTRING_LEN, RSTRING_PTR, RARRAY_LEN and RARRAY_PTR
	    macros.

2006-11-18  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/oraconf.rb: add check code whether oci.h exists.

2006-08-20  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/oraconf.rb: add error code for intel mac.
	* NEWS: add a new file.

2006-08-18  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/oradate.c: add OraDate.hash().
	* ext/oci8/oranumber.c: OraNumber.new() now accepts a String.
	* lib/oci8.rb.in: add YAML support for OraDate and OraNumber.
	* test/test_oranumber.rb: add testcases for OraNumber.new(aString).

2006-08-17  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/oci8.h, ext/oci8/bind.c, ext/oci8/stmt.c:
	    Use long instead of int to bind Fixnum.
	    http://rubyforge.org/forum/forum.php?thread_id=7955&forum_id=1078

2006-08-03  KUBO Takehiro  <kubo@jiubao.org>
	* lib/oci8.rb.in: add a workaround code on cygwin version.
	    Cygwin manages environment variables by itself. They don't
	    synchroize with Win32's ones. set some Oracle's environment
	    variables to win32.

2006-07-29  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/oradate.c: add OraDate#dup, OraDate#clone, OraDate#_dump
	    and OraDate._load.
	* ext/oci8/oranumber.c: add OraNumber#dup, OraNumber#clone,
	    OraNumber#_dump and OraNumber._load.
	* test/test_oradate.rb: add tests for OraDate#dup, OraDate#clone,
	    OraDate#_dump and OraDate._load.
	* test/test_oranumber.rb: add tests for OraNumber#dup,
	    OraNumber#clone, OraNumber#_dump and OraNumber._load.
	* test/test_dbi.rb, test/test_oci8.rb, ext/oci8/oraconf.rb,
	  ext/oci8/extconf.rb, lib/oci8.rb.in, ext/oci8/ocinumber.c:
	    fix for ruby 1.6.

2006-07-21  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/oci8.h, ext/oci8/bind.c, ext/oci8/stmt.c, lib/oci8.rb.in:
	    Support LONG and LONG RAW longer than 65535 bytes.
	    Add OCI8#long_read_len and OCI8#long_read_len= to set max long
	    length.
	* ext/oci8/oraconf.rb: fix typo.

2006-07-20  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/oci8.c, ext/oci8/env.c: move workaround code for
	    instant client environment variable problem from
	    ext/oci8/oci8.c to ext/oci8/env.c.
	* ext/oci8/oraconf.rb: check a c develop file when linux.
	* VERSION, Makefile, ext/oci8/extconf.rb: read version string from
	    the VERSION file.
	* lib/oci8.rb.in: use OCIEnv.create when it exists.

2006-04-23  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/extconf.rb: disable OCIServerRelease checking.
	    That's because mswin32 binary is for 8.1 or later, but 8.1.5
	    doesn't have OCIServerRelease.
	* ext/oci8/oci8.c: call ruby_setenv on loading oci8lib.so. This is
	    a workaround for the following problem: OCIInitialize()
	    implicitly set environment variables. But is make environment
	    variables invalid when setting $0.
	* ext/oci8/oraconf.rb: fix for OracleXE windows version. OracleXE's
	    registry path is \\HKEY_LOCAL_MACHINE\SOFTWARE\ORACLE\KEY_XE.

2006-04-23  KUBO Takehiro  <kubo@jiubao.org>
	* Makefile: change version to 0.1.15.
	* README: add note for Intel Mac.
	* ext/oci8/extconf.rb: change version to 0.1.15.

2006-04-05  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/attr.c: Fix segmentation fault while GC runs at exit.
	    It was caused by freeing OCIEnv before freeing OCIRowid.
	    Now when freeing OCIEnv, OCIRowid is freed in advance.
	* ext/oci8/const.c, ext/oci8/handle.c, ext/oci8/oci8.h, ext/oci8/stmt.c:
	    Fix a memory leak when binding a placeholder which is already
	    bound. In C layer, bind handles were registered to an Array.
	    There is no chance to unregister it except closing Cursor.
	    Now bind handles are registered to a Hash. When already bound
	    placeholder is bound, the old bind handle is unregistered.
	* lib/oci8.rb.in: initialize @prefetch_rows.

2006-03-05  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/oraconf.rb: add check_ruby_header to warn when
	    broken darwin ruby.
	    add export #{ld_path} in check_instant_client().

2006-02-26  KUBO Takehiro  <kubo@jiubao.org>
	release as 0.1.14.
	* ext/oci8/const.c: add OCI_PTYPE_UNK.

2006-02-25  KUBO Takehiro  <kubo@jiubao.org>
	* Makefile: change version to 0.1.14.
	* ext/oci8/bind.c: fix to accept OCIBind#set(aNumeric).
	* ext/oci8/extconf.rb: change version to 0.1.14.
	    fix to compile ocinumber.c also.
	* ext/oci8/oci8.h: add set_oci_vnumber() prototype.
	* ext/oci8/ocinumber.c: add a new file for set_oci_vnumber().
	* lib/oci8.rb.in: setup OCI environment as an object mode.

2006-02-17  KUBO Takehiro  <kubo@jiubao.org>
	* README: fix documentation bug.
	* ext/oci8/attr.c: add attrGet(OCI_ATTR_SERVER) and attrSet(OCI_ATTR_DESC_PUBLIC, -1).
	* ext/oci8/env.c: delete code to register malloc/realloc/free callbacks.
	* ext/oci8/handle.c: free memory by calling xfree(), not by free()
	   in oci8_handle_cleanup().
	* lib/oci8.rb.in: use OCIEnv#logon for non-privilege login.
	    add OCI8#prefetch_rows= and OCI8::Cursor#prefetch_rows=.
	    use @srv instead of @svc in OCI8#non_blocking= for
	    non-privilege login.
	* lib/DBD/OCI8/OCI8.rb: fix to work with ruby-oci8 0.1 and ruby-oci8 0.2 either.

2005-10-15  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/handle.c: fix memory leaks. 700k per 10000 queries.
	  fixed by Nathaniel Talbott. Thank you!
	* ext/oci8/oraconf.rb: add -R to linker on Solaris and Linux.
	  http://rubyforge.org/tracker/index.php?func=detail&aid=2148&group_id=256&atid=1051
	* lib/oci8.rb.in: add DateTime suppport. suggested by Daniel Berger.
	* test/test_dbi.rb, test/test_oci8.rb: testcases for DateTime.
	* test/test_oradate.rb: delete an unsuccessfull testcase, which depends on libc implementation.
	* README: add bind-types.
	* Makefile, ext/oci8/extconf.rb: change version to 0.1.13.

2005-07-20  KUBO Takehiro  <kubo@jiubao.org>
	* README: rewrite.
	* ext/oci8/oraconf.rb: 1. try $libs which works on many cases then
	  get from demo_rdbms.mk. 2. don't read sysliblist when instant client.
	  3. rewrie OraConf#check_lp64().
	* Makefile, ext/oci8/extconf.rb: change version to 0.1.12.

2005-07-16  KUBO Takehiro  <kubo@jiubao.org>
	* metaconfig: move "require 'base64'" and "require 'zlib'" to the
	  next line of "def get_zcontent(file)" for a ruby which doesn't
	  have 'zlib'.

2005-05-31  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/oraconf.rb: fix for cygwin. fix for oracle instant client.
	* metaconfig: add distbin task.

2005-05-29  KUBO Takehiro  <kubo@jiubao.org>
	* lib/oci8.rb.in: add OCI8::BindType::Mapping[:number_unknown_prec]
	  and OCI8::BindType::Mapping[:number_no_prec_setting].
	* ext/oci8/oraconf.rb: copy from oraconf.rb of ruby-oci8 0.2.
	* ext/oci8/lob.c: delete OCILobLocator#getChunkSize on Oracle 8.0.
	  use OCILobAssign() instead of OCILobLocatorAssign() on Oracle 8.0.
	* ext/oci8/extconf.rb: add have_func("OCILobGetChunkSize") and
	  have_func("OCILobLocatorAssign") for Oracle 8.0.
	* Makefile, ext/oci8/extconf.rb: change version to 0.1.11
	* README: add '5. How to customize fetched datatypes.'

2005-03-24  KUBO Takehiro  <kubo@jiubao.org>
	* branch as oci8-0-1.
	* oci8.rb.in: fix bug on binding Time or Date.
	* Makefile, ext/oci8/extconf.rb: change version to 0.1.10.1

2005-03-23  KUBO Takehiro  <kubo@jiubao.org>
	* oci8.rb.in, OCI8.rb:
	delete OCI8.register_type_fixer, OCI8::TypeFixer.
	add OCI8::BindType::* instead.

2005-03-21  KUBO Takehiro  <kubo@jiubao.org>
	* oci8.rb.in, OCI8.rb: refactoring OCI8::Cursor#define_a_column
	* Makefile, ext/oci8/extconf.rb: change version to 0.1.10

2005-03-20  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/stmt.c, lib/oci8.rb.in, lib/DBD/OCI8/OCI8.rb, test/test_dbi.rb:
	  enable DATE to be bound as a DBI::Date or a DBI::Timestamp.

2005-03-20  KUBO Takehiro  <kubo@jiubao.org>
	* ext/oci8/stmt.c, lib/oci8.rb.in, test/test_oci8.rb:
	  bind a ref cursor as an OCI8::Cursor.
          apply a patch at <URL:http://rubyforge.org/tracker/index.php?func=detail&aid=1409&group_id=256&atid=1053>.

2005-01-16  KUBO Takehiro  <kubo@jiubao.org>

	* lib/oci8.rb.in: change default bindtype for NUMBER with
	  unspecified scale.
	  (This problem is reported by William Lawson, Dmitry Maksyoma and Andreas Habel)
	* lib/oci8.rb.in: add OCI8::Cursor.select_number_as=
	  (for someone who want old bindtype)
	* lib/oci8.rb.in: add OCI8::Cursor#fetch_hash
	  (contributed by Jason Sweat)
	* ext/oci8/oci8.h, ext/oci8/stmt.c: don't raise an error when OCI_SUCCESS_WITH_INFO.
	  (suggested by Kenji Nishishiro)
	* ext/ooi8/oraconf.rb: support Oracle Instant Installer.
	  (suggested by Eustaquio Rangel de Oliveira Jr.)
	* Makefile, ext/oci8/extconf.rb: change version to 0.1.9

2004-10-30  KUBO Takehiro  <kubo@jiubao.org>

	* pre-distclean.rb: delete a temporary file made by ext/oci8/oraconf.rb.
	* ext/oci8/oraconf.rb: 1. change object files to an archive file
	  to work around on Oracle 8.1.7. 2. raise error when OCI.H can't
	  be found on Windows.

2004-06-21  KUBO Takehiro  <kubo@jiubao.org>

	* Makefile, ext/oci8/extconf.rb: change version to 0.1.8-pre1
	* lib/DBD/OCI8/OCI8.rb: add DBI::DatabaseHandle#tables. add DBI::StatementHandle#func(:bind_value, ...).

2004-03-07  KUBO Takehiro  <kubo@jiubao.org>

	* ext/oci8/extconf.rb: fix to use setup.rb.
	* ext/oci8/oraconf.rb: add support Borland C++ Builder.
	* lib/oci8.rb.in: support OCI8::CLOB.
	* test/config.rb: CLOB test file depends on NLS_LANG.
	* test/test_oci8.rb: fix a test method.
	* test/test_break.rb: break time depends on OS?...
	* test/test_dbi_clob.rb: add a new file to test CLOB via DBI.

2003-09-20  KUBO Takehiro  <kubo@jiubao.org>

	* src/handle.c: fix bug of OCI8::BLOB at running GC.
	* src/stmt.c: accept Bignum as (({type})) of OCI8::Cursor#define.
	* src/lib/oci8.rb.in: accept OCI8::BLOB as (({type})) of OCI8::Cursor#define.
	* src/lib/DBD/OCI8/OCI8.rb: add (({define})) function to DBD::OCI8.
	* src/oranumber.c, src/oci8.h: use rb_cstr_to_dbl instead of strtod for ruby 1.8.
	* support/runit/cui/testrunner.rb, support/runit/testcase.rb: fix for ruby 1.8.
	* test/test_dbi.rb: add a test method.
	* test/test_oci8.rb: fix a test method.

2003-08-03  KUBO Takehiro  <kubo@jiubao.org>

	* Makefile: update version to 0.1.5
	* MANIFEST: add test/test_oci8.rb
	* src/lib/oci8.rb.in: implement OCI8::Cursor#define, OraDate#to_time and OraDate#to_date.
	* test/test_oci8.rb: add new tests of OCI8::Cursor#define.
	* test/test_oradate.rb: add new tests of OraDate#to_time and OraDate#to_date.
	* test/test_all.rb: call test_oci8.rb.

2003-07-20  KUBO Takehiro  <kubo@jiubao.org>

	* src/stmt.c: When the error "ORA-01000: maximum open cursors
	  exceeded" happens, run garbage collect to close unused cursors
	  and retry automatically.

2003-06-07  KUBO Takehiro  <kubo@jiubao.org>

	* Makefile: update version to 0.1.4
	* src/lob.c: add OCILobLocator#clone()
	* src/bind.c, src/stmt.c, src/lib/oci8.rb.in: fix BLOB support.
	* src/lib/DBD/OCI8/OCI8.rb: set the backtrace of an original exception
	 to newly created DBI exception.
	* src/oraconf.rb: retry get_libs with postfix '32' when	compilation
	 failed with Oracle 9i on Solaris.
	* src/oradate.c: add OraDate#<=> and include 'Comparable'.
	 (contributed by Brian Candler)
	* test/test_oradate.rb: add test cases of OraDate#<=>.

2003-04-27  KUBO Takehiro  <kubo@jiubao.org>

	* Makefile: update version to 0.1.3
	* doc/api.*.rd, doc/api.*.html: update document.
	* src/lob.c: add new LOB APIs.
	* src/lib/oci8.rb.in: add BLOB support.
	* src/lib/DBD/OCI8/OCI8.rb: add 'NonBlocking' support(suggested by Brian Candler).
	raise subclass of DBI::DatabaseError, which depends on its error code.

2003-03-08  KUBO Takehiro  <kubo@jiubao.org>

	* Makefile: update version to 0.1.2
	* src/extconf.rb: use Oraconf#cc_is_gcc.
	* src/oraconf.rb: support Solaris with gcc.
	* src/handle.c: suppress warning about uninitialized instance variables.
	* src/oranumber.c, test/test_oranumber.rb: fix serious bug of 
	conversion routine from Oracle internal number format to string.

2003-02-01  KUBO Takehiro  <kubo@jiubao.org>

	* Makefile: update version to 0.1.1.
	* src/oraconf.rb: added. Oracle specific features were moved from
	src/extconf.rb, src/extunix.rb and src/extwin32.rb
	* src/extunix.rb, src/extwin32.rb: deleted.
	* src/extconf.rb: use oraconf.rb.
	* src/error.c, src/oci8.h: use macro RBOCI_NORETURN not NORETURN.
	* MANIFEST, Makefile: fix for added and deleted files.

2002-09-12  KUBO Takehiro  <kubo@jiubao.org>

	* Makefile: update version to 0.1.0.
	* README: support cygwin and mingw32.
	* test/test_oradate.rb: delete test_now().
	* src/extconf.rb: support mingw32.

2002-09-12  Hitoshi Endoh <h-endoh@mbf.nifty.com>

	* src/extwin32.rb: support cygwin.

2002-09-12  KUBO Takehiro  <kubo@jiubao.org>

	* ChangeLog: Added.
